/*
 * Ecgr6118aUI.java
 *
 * Created on August 4, 2006, 12:13 AM
 */

package tpw.ecgr6118a;
import javax.swing.*;
import java.awt.*;  //needed for Graphics class inclusion
import javax.imageio.*;  //needed for ImageIO
import java.awt.image.*;  //needed for BufferedImage
import java.io.*;  //needed for File


/**
 *
 * @author  Owner
 */
public class Ecgr6118aUI extends javax.swing.JFrame {
    
    /** Creates new form Ecgr6118aUI */
    public Ecgr6118aUI() {
        initComponents();
        
        //set up default drawing
        oval = new Rectangle(20,30,10,20); //topleft-x,y-ccord, wid, height
        ovalColor = new Color(0,0,0);
        area = new Dimension(400,200); //(width,height)
        
        //Set up the drawing area.
       drawpanel = new InnerClassDrawingPanel();
       jScrollPaneDrawingArea.setViewportView(drawpanel);

        drawpanel.setBackground(Color.white);
        drawpanel.setPreferredSize(area);
        drawpanel.revalidate();
        drawpanel.repaint();
        drawpanel.setAutoscrolls(true); //allows dragging?
        
 //below added for image panel area
 //---------------------------------------------------------
        //initialize variables to null to hopefully suppress rendering
            imgFileName = null;
            imgIo = null;
            buffImg = null;
            imgFile = null;
            iconLabel = null;
            imageIcon = null;
            
        //Set up the drawing area.
            imagepanel = new InnerClassImagePanel();
            jScrollPaneImageArea.setViewportView(imagepanel);
            iconLabel  = new JLabel();  //this label will contain the image
            imagepanel.add(iconLabel); //attach the label to the drawing panel
            imagepanel.revalidate();
            imagepanel.repaint();
            imagepanel.setAutoscrolls(true); //allows dragging?
            
                 
 //end  added for image panel area        
 //---------------------------------------------------------
      
            
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        jLabelFileName = new javax.swing.JLabel();
        jTextFieldFileName = new javax.swing.JTextField();
        jButtonFileName = new javax.swing.JButton();
        jButtonDraw = new javax.swing.JButton();
        jPanelDrawingArea = new javax.swing.JPanel();
        jScrollPaneDrawingArea = new javax.swing.JScrollPane();
        jPanelImageArea = new javax.swing.JPanel();
        jScrollPaneImageArea = new javax.swing.JScrollPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        jPanel1.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        jLabelFileName.setText("File Name");

        jButtonFileName.setText("Read");
        jButtonFileName.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButtonFileNameMouseClicked(evt);
            }
        });

        jButtonDraw.setText("Draw");
        jButtonDraw.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                JButtonDrawMouseClick(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jLabelFileName)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jTextFieldFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 123, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(54, 54, 54)
                .add(jButtonFileName)
                .add(22, 22, 22)
                .add(jButtonDraw)
                .addContainerGap(22, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabelFileName)
                    .add(jTextFieldFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jButtonFileName)
                    .add(jButtonDraw))
                .addContainerGap(34, Short.MAX_VALUE))
        );

        jPanelDrawingArea.setBorder(javax.swing.BorderFactory.createTitledBorder("DrawingArea"));

        org.jdesktop.layout.GroupLayout jPanelDrawingAreaLayout = new org.jdesktop.layout.GroupLayout(jPanelDrawingArea);
        jPanelDrawingArea.setLayout(jPanelDrawingAreaLayout);
        jPanelDrawingAreaLayout.setHorizontalGroup(
            jPanelDrawingAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jScrollPaneDrawingArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 383, Short.MAX_VALUE)
        );
        jPanelDrawingAreaLayout.setVerticalGroup(
            jPanelDrawingAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPaneDrawingArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 64, Short.MAX_VALUE)
        );

        jPanelImageArea.setBorder(javax.swing.BorderFactory.createTitledBorder("ImageArea"));

        org.jdesktop.layout.GroupLayout jPanelImageAreaLayout = new org.jdesktop.layout.GroupLayout(jPanelImageArea);
        jPanelImageArea.setLayout(jPanelImageAreaLayout);
        jPanelImageAreaLayout.setHorizontalGroup(
            jPanelImageAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPaneImageArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 383, Short.MAX_VALUE)
        );
        jPanelImageAreaLayout.setVerticalGroup(
            jPanelImageAreaLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPaneImageArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 103, Short.MAX_VALUE)
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanelImageArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanelDrawingArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanelDrawingArea, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanelImageArea, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void JButtonDrawMouseClick(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_JButtonDrawMouseClick
// TODO add your handling code here:
        
        ovalColor=Color.RED;
        drawpanel.setBackground(Color.YELLOW);
        jScrollPaneDrawingArea.setBackground(Color.BLUE);
        drawpanel.setForeground(ovalColor);
        oval.setBounds(60, 30, 20, 10);
        area.setSize(500,200); //width,height
        
    }//GEN-LAST:event_JButtonDrawMouseClick

    private void jButtonFileNameMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jButtonFileNameMouseClicked
// TODO add your handling code here:
          
        //BufferedImage and ImageIO method
        imgFileName = jTextFieldFileName.getText();
        jTextFieldFileName.setText("Read Button Pressed!");      
        imgFileName=new String("imgs/image512x512.gif");
        imgFile = new File(imgFileName);  
        int ioflag = 0;
        
        try { buffImg = imgIo.read(imgFile) ; } 
          catch (IOException e) {
              System.out.println("public jButtonFileNameMouseClicked::imgIo.read IOException");
              ioflag=1;
             }
        
        if(ioflag == 0)
        {
            System.out.println("file width=" + buffImg.getWidth()
                    +" length=" + buffImg.getHeight() );
        
            //why not draw a line on the image
            Graphics gg = buffImg.createGraphics();
            gg.setColor(Color.MAGENTA);
            gg.drawLine(10,10,buffImg.getWidth()-buffImg.getWidth()/10,
                    buffImg.getHeight()-buffImg.getHeight()/2);
            
            //save the file after drawing the line on it
            File outfile = new File("imgs/out.jpg");
            try {ImageIO.write(buffImg,"JPG",outfile); } 
              catch (IOException e) {
                  System.out.println("jButtonFileNameMouseClicked::"
                          +"outfilewrite IOException");
                 }  
            
            //examples of reading and writing pixel data
            int rgb =0;
            int alpha=0 , red=0 , green=0 , blue=0; 
            int a=255 , r=0 , g=200 , b=0; 
            int xx=20;
        
            for(int yy=0; yy<30; yy++)  //read and write some pixels
                {
                   rgb = buffImg.getRGB(xx, yy) ;  //read pixel
                   alpha = ((rgb >> 24) & 0xff); 
                   red = ((rgb >> 16) & 0xff); 
                   green = ((rgb >> 8) & 0xff); 
                   blue = ((rgb ) & 0xff); 
                   System.out.println("yy="+ yy +" pix=" + buffImg.getRGB(xx, yy)
                        + " red=" + red + " green="  + green + " blue=" + blue
                        +" alpha=" +alpha );          
                   //change the pixels to green  
                   a=255;  r=0;  g=200;  b=0; 
                   rgb = (a << 24) | (r << 16) | (g << 8) | b; 
                   buffImg.setRGB(xx, yy, rgb);    //write pixel
                  }
             
            imageIcon=new ImageIcon(buffImg);
            iconLabel.setIcon(imageIcon);
            iconLabel  = new JLabel(imageIcon);
            imagepanel.removeAll();
            imagepanel.add(iconLabel,0);
            imagepanel.setBackground(Color.YELLOW);
            jScrollPaneImageArea.setBackground(Color.BLUE);
           
            imagepanel.revalidate();
            imagepanel.repaint();
            imagepanel.setAutoscrolls(true); //allows dragging?
        }
        
    }//GEN-LAST:event_jButtonFileNameMouseClicked
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Ecgr6118aUI().setVisible(true);
            }
        });
    }

    public final class InnerClassDrawingPanel extends javax.swing.JPanel {    
          protected void paintComponent(Graphics g) {
            super.paintComponent(g);
       
        g.setColor( ovalColor );
        g.fillOval(oval.x,oval.y,oval.width,oval.height);     
        drawpanel.setAutoscrolls(true); 
          }
    }

    

    public final class InnerClassImagePanel extends javax.swing.JPanel {
           
           protected void paintComponent(Graphics g) {
            super.paintComponent(g);
                /*   //following not used .. may be helpful for debug
                    drawpanel.revalidate(); 
                    drawpanel.repaint();
                */ 
            drawpanel.setAutoscrolls(true); //allows dragging?
            }
          
    }


    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonDraw;
    private javax.swing.JButton jButtonFileName;
    private javax.swing.JLabel jLabelFileName;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelDrawingArea;
    private javax.swing.JPanel jPanelImageArea;
    private javax.swing.JScrollPane jScrollPaneDrawingArea;
    private javax.swing.JScrollPane jScrollPaneImageArea;
    private javax.swing.JTextField jTextFieldFileName;
    // End of variables declaration//GEN-END:variables
    
     //begin our manually added variables
    private InnerClassDrawingPanel drawpanel;
    private Dimension area;
    private Rectangle oval;
    private Color ovalColor;
    //end our manually added variables
    
    //begin our second set of manually added variables
    private InnerClassImagePanel imagepanel;
    private String imgFileName;
    private ImageIO imgIo;
    private BufferedImage buffImg;
    private File imgFile;
    private JLabel iconLabel;
    private ImageIcon imageIcon;
   //end our second set manually added variables

    
}
